<script type="text/javascript">
  $(function () {
    var $topDiscourseSub = $("#top-discourse-sub");
    $("#top-discourse-link").hover(
      function () {
        $topDiscourseSub.show();
      },
      function () {
        $topDiscourseSub.hide();
      }
    );
  });
</script>
<script type="text/discourse-plugin" version="0.8">
  controller = api.container.lookup('controller:composer');

  controller.reopen({
    showPreview: false
  })
</script>

<script type="text/x-handlebars" data-template-name="user">
  {{plugin-outlet name="above-user-profile" tagName="" args=(hash model=model)}}
  <div class="container {{if viewingSelf "viewing-self"}} {{if model.profile_hidden "profile-hidden"}}">
    {{#d-section class="user-main"}}
      <section class="{{if collapsedInfo "collapsed-info"}} about {{if hasProfileBackgroundUrl "has-background" "no-background"}}" >
        {{#unless collapsedInfo}}
          {{#if showStaffCounters}}
            <div class="staff-counters">
              {{#if model.number_of_flags_given}}
                <div><span class="helpful-flags">{{model.number_of_flags_given}}</span>{{i18n "user.staff_counters.flags_given"}}</div>
              {{/if}}
              {{#if model.number_of_flagged_posts}}
                <div>
                  {{#link-to "review" (query-params username=model.username status="all" type="ReviewableFlaggedPost")}}
                    <span class="flagged-posts">{{model.number_of_flagged_posts}}</span>{{i18n "user.staff_counters.flagged_posts"}}
                  {{/link-to}}
                </div>
              {{/if}}
              {{#if model.number_of_rejected_posts}}
                <div>
                  {{#link-to "review" (query-params username=model.username status="rejected" type="ReviewableQueuedPost")}}
                    <span class="flagged-posts">{{model.number_of_rejected_posts}}</span>{{i18n "user.staff_counters.rejected_posts"}}
                  {{/link-to}}
                </div>
              {{/if}}

              {{#if model.number_of_deleted_posts}}
                <div>
                  {{#link-to "user.deletedPosts" model}}
                    <span class="deleted-posts">{{model.number_of_deleted_posts}}</span>{{i18n "user.staff_counters.deleted_posts"}}
                  {{/link-to}}
                </div>
              {{/if}}
              {{#if model.number_of_suspensions}}
                <div>
                  <a href {{action "showSuspensions"}}>
                    <span class="suspensions">{{model.number_of_suspensions}}</span>{{i18n "user.staff_counters.suspensions"}}
                  </a>
                </div>
              {{/if}}
              {{#if model.warnings_received_count}}
                <div><span class="warnings-received">{{model.warnings_received_count}}</span>{{i18n "user.staff_counters.warnings_received"}}</div>
              {{/if}}
            </div>
          {{/if}}
          <div class="user-profile-image" style={{model.profileBackgroundUrl}}></div>
        {{/unless}}
        <div class="details">
          <div class="primary">
            {{user-profile-avatar user=model tagName=""}}
            <section class="controls">
              <ul>
                {{#if model.can_send_private_message_to_user}}
                  <li>
                    {{d-button class="btn-primary compose-pm"
                      action=(route-action "composePrivateMessage" model)
                      icon="envelope"
                      label="user.private_message"}}
                  </li>
                {{/if}}
                {{#if canMuteOrIgnoreUser}}
                  <li>
                    {{user-notifications-dropdown
                        user=model
                        value=userNotificationLevel
                        updateNotificationLevel=(action "updateNotificationLevel")
                    }}
                  </li>
                {{/if}}
                {{#if currentUser.staff}}
                  <li><a href={{model.adminPath}} class="btn btn-default">{{d-icon "wrench"}}<span class="d-button-label">{{i18n "admin.user.show_admin_profile"}}</span></a></li>
                {{/if}}
                {{plugin-outlet name="user-profile-controls"
                                tagName=""
                                connectorTagName="li"
                                args=(hash model=model)}}

                {{#if canExpandProfile}}
                  <li>
                    {{d-button
                      ariaExpanded=collapsedInfoState.isExpanded
                      ariaControls="collapsed-info-panel"
                      label=(concat "user." collapsedInfoState.label)
                      icon=collapsedInfoState.icon
                      action=(action collapsedInfoState.action)
                    }}
                  </li>
                {{/if}}
              </ul>
            </section>

            <div class="primary-textual">
              <div class="user-profile-names">
                <h1 class={{if nameFirst "username" "full-name"}}>{{#if nameFirst}}{{model.username}}{{else}}{{model.name}}{{/if}}</h1>
                <h2 class={{if nameFirst "full-name" "username"}}>{{if nameFirst model.name (format-username model.username)}} {{user-status model currentUser=currentUser}}</h2>
                {{#if model.staged}}
                  <h2 class="staged">{{i18n "user.staged"}}</h2>
                {{/if}}
                {{#if model.title}}
                  <h3>{{model.title}}</h3>
                {{/if}}
                {{plugin-outlet name="user-post-names" args=(hash model=model)}}
              </div>

              {{#if showFeaturedTopic}}
                <h3 class="featured-topic">
                  <span>{{i18n "user.featured_topic"}}</span>
                  {{#link-to "topic" model.featured_topic.slug model.featured_topic.id}}{{html-safe (replace-emoji model.featured_topic.fancy_title)}}{{/link-to}}
                </h3>
              {{/if}}

              <h3 class="location-and-website">
                {{#if model.location}}<div class="user-profile-location">{{d-icon "map-marker-alt"}} {{model.location}}</div>{{/if}}
                {{#if model.website_name}}
                  <div class="user-profile-website">
                    {{d-icon "globe"}}
                    {{#if linkWebsite}}
                      {{!-- template-lint-disable  --}}
                      <a href={{model.website}} rel="noopener {{unless removeNoFollow 'nofollow ugc'}}" target="_blank">{{model.website_name}}</a>
                    {{else}}
                      <span title={{model.website}}>{{model.website_name}}</span>
                    {{/if}}
                  </div>
                {{/if}}
                {{plugin-outlet name="user-location-and-website" args=(hash model=model)}}
              </h3>

              <div class='bio'>
                {{#if model.suspended}}
                  <div class='suspended'>
                    {{d-icon "ban"}}
                    <b>
                      {{#if model.suspendedForever}}
                        {{i18n 'user.suspended_permanently'}}
                      {{else}}
                        {{i18n 'user.suspended_notice' date=model.suspendedTillDate}}
                      {{/if}}
                    </b>
                    <br>
                    {{#if model.suspend_reason}}
                      <b>{{i18n 'user.suspended_reason'}}</b> {{model.suspend_reason}}
                    {{/if}}
                  </div>
                {{/if}}
                {{#if isNotSuspendedOrIsStaff}}
                  {{#html-with-links}}
                    {{html-safe model.bio_cooked}}
                  {{/html-with-links}}
                {{/if}}
              </div>

              {{#if publicUserFields}}
                <div class="public-user-fields">
                  {{#each publicUserFields as |uf|}}
                    {{#if uf.value}}
                      <div class="public-user-field {{uf.field.dasherized_name}}">
                        <span class="user-field-name">{{uf.field.name}}</span>:
                        <span class="user-field-value">{{uf.value}}</span>
                      </div>
                    {{/if}}
                  {{/each}}

                  {{plugin-outlet name="user-profile-public-fields"
                                  args=(hash publicUserFields=publicUserFields
                                        model=model)}}
                </div>
              {{/if}}

              {{plugin-outlet name="user-profile-primary" args=(hash model=model)}}
            </div>
          </div>
          {{#unless collapsedInfo}}
            <div class='secondary' id='collapsed-info-panel'>
              <dl>
                {{#if model.created_at}}
                  <div><dt>{{i18n 'user.created'}}</dt><dd>{{bound-date model.created_at}}</dd></div>
                {{/if}}
                {{#if model.last_seen_at}}
                  <div><dt>{{i18n 'user.last_seen'}}</dt><dd>{{bound-date model.last_seen_at}}</dd></div>
                {{/if}}
                {{#if canCheckEmails}}
                  <div><dt>{{i18n 'user.email.title'}}</dt>
                  <dd title={{model.email}}>
                    {{#if model.email}}
                      {{model.email}}
                    {{else}}
                      {{d-button action=(route-action "checkEmail") actionParam=model icon="far-envelope" label="admin.users.check_email.text" class="btn-primary"}}
                    {{/if}}
                  </dd>
                  </div>
                {{/if}}
                {{#if model.groups}}
                  <div><dt class="groups">{{i18n 'groups.title' count=model.displayGroups.length}}</dt>
                  <dd class='groups'>
                    {{#each model.groups as |group|}}
                      <span>
                        {{#link-to 'group' group.name class="group-link"}}
                          {{#if group.full_name}}
                            {{group.full_name}}
                          {{else}}
                            {{group.name}}
                          {{/if}}
                        {{/link-to}}
                      </span>
                    {{/each}}
                  </dd>
                  </div>
                {{/if}}

                {{#if canDeleteUser}}
                  <div class='pull-right'>{{d-button action=(action "adminDelete") icon="exclamation-triangle" label="user.admin_delete" class="btn-danger"}}</div>
                {{/if}}
              </dl>
              {{plugin-outlet name="user-profile-secondary" args=(hash model=model)}}
            </div>
          {{/unless}}
        </div>
      </section>
    {{/d-section}}
  </div>
</script>

<script type="text/x-handlebars" data-template-name="group">
  {{plugin-outlet name="before-group-container" args=(hash group=model)}}

  <div class="container group {{model.name}}">
    {{#if showTooltip}}
      <div class="group-delete-tooltip">
        <p>{{i18n "admin.groups.delete_automatic_group"}}</p>
      </div>
    {{/if}}

    <div class="group-details-container">
      <div class="group-info">
        {{#if model.flair_url}}
          <div class="group-avatar-flair">
            {{avatar-flair
              flairURL=model.flair_url
              flairBgColor=model.flair_bg_color
              flairColor=model.flair_color
              groupName=model.name
            }}
          </div>
        {{/if}}

        <div class="group-info-names">
          <span class="group-info-name">{{groupName}}</span>

          {{#if model.full_name}}<div class="group-info-full-name">{{model.name}}</div>{{/if}}
        </div>

        <div class="group-details-button">
          {{group-membership-button
            tagName=""
            model=model
            showLogin=(route-action "showLogin")
          }}

          {{#if currentUser.admin}}
            {{#if model.automatic}}
              {{d-button
                action=(action "toggleDeleteTooltip")
                class="btn-default"
                icon="question-circle"
                label="admin.groups.delete"
              }}
            {{else}}
              {{d-button
                action=(action "destroy")
                disabled=destroying
                icon="trash-alt"
                class="btn-danger"
                label="admin.groups.delete"
              }}
            {{/if}}
          {{/if}}
        </div>

        {{plugin-outlet name="group-details-after" args=(hash model=model)}}
      </div>

      {{#if model.bio_cooked}}
        <hr>

        <div class="group-bio">
          <p>{{html-safe model.bio_cooked}}</p>
        </div>
      {{/if}}
    </div>

    <div class="user-content-wrapper">
      <section class="user-primary-navigation">
        <div class="container">
          {{group-navigation group=model currentPath=currentPath tabs=tabs}}
        </div>
      </section>

      {{outlet}}
    </div>
  </div>
</script>

<script type="text/x-handlebars" data-template-name="group-index">
  <section class="user-content">
    <div class="group-members-actions">
      {{#if model.can_see_members}}
        {{text-field
          value=filterInput
          placeholderKey=filterPlaceholder
          autocomplete="discourse"
          class="group-username-filter no-blur"
        }}
      {{/if}}

      <div class="group-members-manage">
        {{#if canManageGroup}}
          {{d-button icon="plus"
            action=(route-action "showAddMembersModal")
            label="groups.manage.add_members"
          class="group-members-add"}}
        {{/if}}
      </div>
    </div>

    {{#if hasMembers}}
      {{#load-more selector=".group-members tr" action=(action "loadMore")}}
        <table class="group-members">
          <thead>
            <tr>
              {{#if isBulk}}
                <th class="bulk-select-buttons">
                  {{d-button action=(action "bulkSelectAll") label="topics.bulk.select_all"}}
                  {{d-button action=(action "bulkClearAll") label="topics.bulk.clear_all"}}
                </th>
              {{/if}}
              {{table-header-toggle order=order asc=asc field="username_lower" labelKey="username" class="username"}}
              {{table-header-toggle order=order asc=asc field="location" labelKey=(theme-prefix "groups.location")}}
              {{table-header-toggle order=order asc=asc field="last_seen_at" labelKey="last_seen"}}
              <th>
                {{#if isBulk}}
                  {{group-member-dropdown
                    bulkSelection=bulkSelection
                    canAdminGroup=model.can_admin_group
                    onChange=(action "actOnSelection" bulkSelection)
                  }}
                {{/if}}
              </th>
            </tr>
          </thead>

          <tbody>
            {{#each model.members as |m|}}
              <tr>
                {{#if isBulk}}
                  <td class="bulk-select">
                    {{input type="checkbox" class="bulk-select" click=(action "selectMember" m)}}
                  </td>
                {{/if}}

                <td class="avatar">
                  {{user-info user=m skipName=skipName}}
                </td>
                <td>
                  <span class="text">{{ m.location}}</span>
                </td>
                <td>
                  <span class="text">{{bound-date m.last_seen_at}}</span>
                </td>

                <td>
                  {{#if canManageGroup}}
                    {{group-member-dropdown
                      member=m
                      canAdminGroup=model.can_admin_group
                      onChange=(action "actOnGroup" m)
                    }}
                  {{/if}}
                  {{!-- group parameter is used by plugins --}}
                </td>
              </tr>
            {{/each}}
          </tbody>
        </table>
      {{/load-more}}

      {{conditional-loading-spinner condition=loading}}
    {{else if model.can_see_members}}
      <br>

      <div>{{i18n "groups.empty.members"}}</div>
    {{else}}
      <br>

      <div>{{i18n "groups.members.forbidden"}}</div>
    {{/if}}
  </section>
</script>

<script type="text/x-handlebars" data-template-name="components/user-info">
  <div class="user-image">
    <div class="user-image-inner">
      <a href={{this.userPath}} data-user-card={{@user.username}}>{{avatar @user imageSize="large"}}</a>
      {{#if @user.primary_group_name}}
        {{avatar-flair
          flairURL=@user.primary_group_flair_url
          flairBgColor=@user.primary_group_flair_bg_color
          flairColor=@user.primary_group_flair_color
          groupName=@user.primary_group_name}}
      {{/if}}
    </div>
  </div>

  <div class="user-detail">
    <div class="name-line">
      <span class={{if nameFirst "name bold" "username bold"}}><a href={{this.userPath}} data-user-card={{@user.username}}>{{if nameFirst (format-username @user.username) this.name}}</a></span>
      <span class={{if nameFirst "username margin" "name margin"}}><a href={{this.userPath}} data-user-card={{@user.username}}>{{if nameFirst this.name (format-username @user.username)}}</a></span>
      {{plugin-outlet name="after-user-name" connectorTagName="span" args=(hash user=user)}}
    </div>
    <div class="title">{{@user.title}}</div>

    {{#if hasBlock}}
      <div class="details">
        {{yield}}
      </div>
    {{/if}}

  </div>

  {{plugin-outlet name="after-user-info" args=(hash user=user)}}
</script>

<script type="text/x-handlebars" data-template-name="groups/index">

  {{plugin-outlet name="before-groups-index-container" tagName=""}}

  {{#d-section pageClass="groups"}}
  <div class="groups-header">
    {{#if currentUser.can_create_group}}
      {{d-button
        action=(action "new")
        class="btn-default groups-header-new pull-right"
        icon="plus"
        label="admin.groups.new.title"
      }}
    {{/if}}

    <div class="groups-header-filters">
      {{input
        value=(readonly filter)
        placeholderKey="groups.index.all"
        class="groups-header-filters-name no-blur"
        input=(action "onFilterChanged" value="target.value")
      }}

      {{combo-box
        value=type
        content=types
        class="groups-header-filters-type"
        onChange=(action (mut type))
        options=(hash
          clearable=true
          none="groups.index.filter"
        )
      }}
    </div>
  </div>

  {{#conditional-loading-spinner condition=isLoading}}
    {{#if groups}}
      {{#load-more selector=".groups-boxes .group-box" action=(action "loadMore")}}
        <div class="container">
          <div class="groups-boxes">
            {{#each groups as |group|}}
            <div class="group-box">
            <div class="group-box-inner">
              <div class="group-info-wrapper">
                {{#link-to "group.members" group.name }}
                {{#if group.flair_url}}
                  <span class="group-avatar-flair">
                    {{avatar-flair
                        flairURL=group.flair_url
                        flairBgColor=group.flair_bg_color
                        flairColor=group.flair_color
                        groupName=group.name}}
                  </span>
                {{/if}}
                  <span class="group-info">
                    {{groups-info group=group}}
                    <div class="group-user-count">{{d-icon "user"}}{{group.user_count}}</div>
                  </span>
                {{/link-to}}
              </div>

              <div class="group-description">{{html-safe group.bio_excerpt}}</div>

                <div class="group-membership">
                  {{#group-membership-button tagName="" model=group showLogin=(route-action "showLogin")}}
                    {{#if group.is_group_owner}}
                      <span class="is-group-owner">
                        {{d-icon "shield-alt"}}
                        {{i18n "groups.index.is_group_owner"}}
                      </span>
                    {{else if group.is_group_user}}
                      <span class="is-group-member">
                        {{d-icon "check"}}
                        {{i18n "groups.index.is_group_user"}}
                      </span>
                    {{else if group.public_admission}}
                      {{i18n "groups.index.public"}}
                    {{else if group.isPrivate}}
                      {{d-icon "far-eye-slash"}}
                      {{i18n "groups.index.private"}}
                    {{else}}
                      {{#if group.automatic}}
                        {{i18n "groups.index.automatic"}}
                      {{else}}
                        {{d-icon "ban"}}
                        {{i18n "groups.index.closed"}}
                      {{/if}}
                    {{/if}}
                  {{/group-membership-button}}

                  {{plugin-outlet name="group-index-box-after" args=(hash model=group)}}
                </div>
              </div>
            </div>
            {{/each}}
          </div>
        </div>
      {{/load-more}}

      {{conditional-loading-spinner condition=groups.loadingMore}}
    {{else}}
      <p>{{i18n "groups.index.empty"}}</p>
    {{/if}}
  {{/conditional-loading-spinner}}

  {{/d-section}}
</script>

<script type="text/x-handlebars" data-template-name="users">

  {{#d-section pageClass="users"}}
    {{#load-more selector=".directory tbody tr" action=(action "loadMore")}}
      <div class="container">
        <div class="users-directory directory">
          {{plugin-outlet name="users-top" connectorTagName="div" args=(hash model=model)}}
          <div class="directory-controls">
            <div class="period-controls">
              {{period-chooser period=period onChange=(action (mut period)) fullDay=false}}
              {{#if lastUpdatedAt}}
                <div class="directory-last-updated">
                  {{i18n "directory.last_updated"}}
                  {{lastUpdatedAt}}
                </div>
              {{/if}}
            </div>
            <div>
              <span class="total-rows">
                {{#if model.totalRows}}
                  {{i18n "directory.total_rows" count=model.totalRows}}
                {{/if}}
              </span>
              {{input
                value=(readonly nameInput)
                input=(action "onFilterChanged" value="target.value")
                placeholderKey="directory.filter_name"
                class="filter-name no-blur"
              }}
            </div>
          </div>

          {{#conditional-loading-spinner condition=isLoading}}
            {{#if model.length}}

              <table>
                <thead>
                  {{table-header-toggle field="username" order=order asc=asc}}
                  {{table-header-toggle field="location" order=order asc=asc}}
                  {{table-header-toggle field="days_visited" order=order asc=asc}}
                  {{#if showTimeRead}}
                    <th>{{i18n "directory.time_read"}}</th>
                  {{/if}}
                </thead>
                <tbody>
                  {{#each model as |item|}}
                    {{directory-item item=item showTimeRead=showTimeRead}}
                  {{/each}}
                </tbody>
              </table>

              {{conditional-loading-spinner condition=model.loadingMore}}
            {{else}}
              <div class="clearfix"></div>
              <p>{{i18n "directory.no_results"}}</p>
            {{/if}}
          {{/conditional-loading-spinner}}

        </div>
      </div>
    {{/load-more}}
  {{/d-section}}
</script>

<script type="text/x-handlebars" data-template-name="group-navigation">
  {{#mobile-nav class="group-nav" desktopClass="nav nav-pills"}}
    {{#if site.mobileView}}
      <li>
        {{#link-to "groups.index"}}
          {{i18n "groups.index.all"}}
        {{/link-to}}
      </li>
    {{/if}}

    {{#each tabs as |tab|}}
      <li>
        {{#link-to tab.route group title=tab.message class=tab.name}}
          {{#if tab.icon}}{{d-icon tab.icon}}{{/if}}
          {{tab.message}}
          {{#if tab.count}}<span class="count">({{tab.count}})</span>{{/if}}
        {{/link-to}}
      </li>
    {{/each}}
    {{plugin-outlet name="group-reports-nav-item" args=(hash group=group) tagName="" connectorTagName="li"}}
  {{/mobile-nav}}
</script>

<script type="text/javascript" src="/header.js"></script>
<nav id="rps-header" class="rps-header"></nav>
